/*
   1s

   2000/02/03 Rick
*/

#include	"mview.h"
#include	<stdio.h>
#include	<string.h>
#include	<doslib.h>
#include	<iocslib.h>
#include	"sub.h"


/* Shift_JIS p萔 */
#define	ASCII	0
#define	SJIS1	-1
#define	SJIS2	1

/* ʂ̍ő包 */
#define	VIEWCOLMAX	96

/* eLXg`F (A]\) */
#define	BLACK	0
#define	BLUE	1
#define	YELLOW	2
#define	WHITE	3

/* r[|[g͂ݏoɃWv錅 */
#define	JUMPCOLUMN	4


/* ϐ錾 */

/* CTRL+At@xbgL[p@\e[u */
char	ctrlmap[] = {
	/*  NULL   ^a    ^b    ^c    ^d    ^e    ^f  ^g(BEL) */
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x03,
	/* ^h(BS) ^i(TAB) ^j(LF) ^k  ^l    ^m(CR) ^n   ^o */
		0x07, 0x08, 0x09, 0x0a, 0x00, 0x09, 0x00, 0x00,
	/*   ^p    ^q    ^r    ^s    ^t    ^u    ^v    ^w */
		0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00,
	/*   ^x    ^y  ^z(EOF) ESC  0x1c  0x1d  0x1e  0x1f */
		0x00, 0x00, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00,
};

/* L[p@\e[u */
char	specialmap[] = {
	/*  HOME  DEL   R_UP  R_DW  UNDO  LEFT   UP  RIGHT  DOWN  CLR */
		0x01, 0x04, 0x00, 0x00, 0x0c, 0x02, 0x00, 0x06, 0x00, 0x00
};


/* ֐vg^Cv錾 */

/* 1s͓֐ */

/* J[\` */
extern void	putcursor(int x, int y, int	len);

static unsigned char	*jstrncpy2(unsigned char *dest, unsigned char *src, int num);
static int	adjustcursor(GETLINE *k, int x);
static void	forward(GETLINE *k);
static void	backward(GETLINE *k);
static void	linetop(GETLINE *k);
static void	lineend(GETLINE *k);
static void	insertchr(GETLINE *k, unsigned char c);
static void	delchr(GETLINE *k);
static void	backspace(GETLINE *k);
static void	killtobol(GETLINE *k);
static void	killfromeol(GETLINE *k);
static void	clear(GETLINE *k);
static void	gethome(GETLINE *k);
static void	putline(GETLINE *k);
static unsigned char	bitsns(int row);


/*
	src  dest  num oCgʂBShift_JISl

		unsigned char	*dest	ʐ|C^
			unsigned char	*src	ʌ|C^
			int				num		(byte)

	mview łƂ̈Ⴂ
		2byte ؂鎞	mview	폜
								input	Ԃ炳
		߂l	mview	ʐ̐擪
				input	ʐ̏I[
*/
static unsigned char *jstrncpy2(unsigned char *dest, unsigned char *src, int num)
{
	unsigned char	*p = src, *w = dest;

	while (--num >= 0) {
		if (!nosjis[*p]) {
			*w++ = *p++;
			if (--num < 0) {
				*w++ = *p++;
				break;
			}
		}
		if (!*p)	break;
		*w++ = *p++;
	}
	*w = '\0';

	return w;
}

/*
	2byte2byteڂȂJ[\1߂
	kanjitOĐݒ肷

		GETLINE	*k	GETLINE\
			int	x		ׂJ[\ x ʒu
	߂l	1 : Shift_JIS
			0 : ASCII
*/
static int	adjustcursor(GETLINE *k, int x)
{
	int	i;
	int	kanji = ASCII;

	for (i = 0; i <= x; i++) {
		if (kanji == SJIS1) {
			kanji = SJIS2;
		} else {
			kanji = !nosjis[k->buf[i]];
		}
	}
	if (kanji == SJIS2)	x--;
	k->kanji = kanji;
	return x;
}

/*
	J[\1i߂

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	forward(GETLINE *k)
{
	if (k->cursor < k->len) {
		if (k->kanji)	k->cursor++;
		k->cursor++;
		k->kanji = !nosjis[k->buf[k->cursor]];
	}
}

/*
	J[\1߂

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	backward(GETLINE *k)
{
	if (k->cursor) {
		k->cursor = adjustcursor(k, k->cursor - 1);
	}
}

/*
	J[\obt@擪ɖ߂

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	linetop(GETLINE *k)
{
	k->cursor = 0;
	k->kanji = !nosjis[k->buf[0]];
}

/*
	J[\obt@I[ɐi߂

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	lineend(GETLINE *k)
{
	k->cursor = k->len;
	k->kanji = FALSE;
}

/*
	J[\ʒuɕ}

		GETLINE	*k	GETLINE\
			unsigned char	c	}镶
	߂l	Ȃ
*/
static void	insertchr(GETLINE *k, unsigned char c)
{
	int	p;

	if (k->len >= k->bufsize)	return;

	p = k->cursor;
	while (k->buf[p])	p++;
	k->buf[p + 1] = '\0';
	while (p > k->cursor) {
		k->buf[p] = k->buf[p - 1];
		p--;
	}
	k->buf[k->cursor++] = c;
}

/*
	J[\ʒu̕폜

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	delchr(GETLINE *k)
{
	int	r, w;

	if (k->cursor >= k->len)	return;

	w = k->cursor;
	r = w + 1;
	if (k->kanji)	r++;
	k->kanji = !nosjis[k->buf[r]];
	while (k->buf[r])	k->buf[w++] = k->buf[r++];
	k->buf[w] = '\0';
}

/*
	J[\1߂Ă̕폜

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	backspace(GETLINE *k)
{
	if (!k->cursor)	return;
	k->cursor = adjustcursor(k, k->cursor - 1);
	delchr(k);
}

/*
	J[\ʒuobt@I[܂ō폜

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	killtobol(GETLINE *k)
{
	k->buf[k->cursor] = '\0';
	k->kanji = FALSE;
}

/*
	obt@擪J[\ʒu1O܂ō폜

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	killfromeol(GETLINE *k)
{
	int	src = k->cursor;
	int	dest = 0;

	while (k->buf[src]) {
		k->buf[dest++] = k->buf[src++];
	}
	k->buf[dest] = '\0';

	k->cursor = 0;
}

/*
	obt@Sč폜

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	clear(GETLINE *k)
{
	k->buf[0] = '\0';
	k->cursor = 0;
	k->kanji = FALSE;
}

/*
	r[|[gݒ

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	gethome(GETLINE *k)
{
	k->len = strlen(k->buf);
	if (k->len < k->width) {
		/* all are inside of view */
		k->home = 0;
	} else {
		/* partial view */
		int	x, kanji = k->kanji;
		int	home = k->home;

		if (k->cursor >= home + k->width) {
			/* cursor is right outside of view */
			home = k->cursor - k->width + 1 + JUMPCOLUMN;
			if (home + k->width > k->len) {
				home = k->len - k->width;
			}
		} else if (k->cursor < home) {
			/* cursor is left outside of view */
			home = k->cursor - JUMPCOLUMN;
			if (home < 0)	home = 0;
		}

		/* top of view is SJIS2 ? */
		x = adjustcursor(k, home);
		if (x != home)	home = x + 2;
		k->home = home;

		/* kanji set (again) */
		k->kanji = kanji;
	}
}

/*
	1s\ (`͈͂̍œK͂ĂȂ)

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static void	putline(GETLINE *k)
{
	int	i;
	unsigned char	*p, *w,
					PrnTemp[VIEWCOLMAX + 1];

	gethome(k);
	p = k->buf + k->home;
	w = jstrncpy2(PrnTemp, p, k->width);
	i = w - PrnTemp;

	for (; i < k->width + 1; i++)	*w++ = ' ';
	*w = '\0';

	B_PUTMES(k->color, k->x, k->y, k->width + 1 - 1, PrnTemp);
	putcursor(k->x + k->cursor - k->home, k->y, (k->kanji)?2:1);
}


/*
	ĂL[R[h擾

		int	row	ׂL[O[v
	߂l	L[R[h
*/
static unsigned char	bitsns(int row)
{
	int	i, b;

	i = BITSNS(row);
	for (b = 7; b >= 0; b--) {
		if (i & 0x80)	break;
		i += i;
	}
	return (b >= 0)?(row * 8 + b):0;
}

/*
	1s

		GETLINE	*k	GETLINE\
	߂l	Ȃ
*/
static int	kloop(GETLINE *k)
{
	while (TRUE) {
		unsigned int	i;
		unsigned char	c, b;


		putline(k);

		/* s͂mF */
		while (!(i = B_KEYSNS()));

		/*
		    擪XLR[h擾
		    (KEY.SYS̐ݒ𖳎邽)
		*/
		b = (unsigned char)(i >> 8);

		/* DOSR[ */
		c = INKEY();

		if (b >= 0x70) {
			/* L[ */
			if (b = bitsns(0x06));
			else if (b = bitsns(0x07));
			else if (b = bitsns(0x0a));
			else if (b = bitsns(0x0b));
		}

		/* L[̏ 1 */
		if (0x36 <= b && b <= 0x3f) {
			/* DOSR[͎̓͂̂Ă */
			while (INPOUT(0xff));
			if (!(c = k->specialtbl[b - 0x36]))	continue;

		/* L[̏ 2 */
		/* HELP or INS */
		} else if (b == 0x54 || b == 0x5e) {
			/* DOSR[͎̓͂̂Ă */
			while (INPOUT(0xff));
			continue;

		/*
		   CTRL + SPACE 𔻕ʂ
		   ̕ӂɒǉ
		*/

		/* ʏL[̏ */
		} else if (c >= ' ') {
			/*
			   DOSR[̓͂S}
			   FEP͂ȂR
			*/
			do {
				insertchr(k, c);
			} while (c = INPOUT(0xff));
			continue;

		/* CTRL + At@xbgL[̏ */
		} else {
			c = k->ctrltbl[c];
		}

		/* @\U蕪 */
		switch (c) {
		case 0x00:	break;
		case 0x01:	linetop(k);		break;
		case 0x02:	backward(k);	break;
		case 0x03:	return -1;
		case 0x04:	delchr(k);		break;
		case 0x05:	lineend(k);		break;
		case 0x06:	forward(k);		break;
		case 0x07:	backspace(k);	break;
		case 0x08:	if (k->user)	k->user(k);	break;
		case 0x09:	return k->len;
		case 0x0a:	killtobol(k);	break;
		case 0x0b:	killfromeol(k);	break;
		case 0x0c:	clear(k);		break;
		default:	break;
		}
	}
}

int	kinput(GETLINE *k)
{
	int	ret;

	/* L[{[hs͂̂Ă */
	KFLUSHIO(0xff);

	/*
	  emacs l B_KEYSNS() tbN
	  J[\_ł𐧌
	*/
	intercept();

	ret = kloop(k);

	/* B_KEYSNS() ɖ߂ */
	intercept_end();

	return ret;
}

void	dummy(GETLINE *k)
{
	/* stab */
}
