/* viewer for mview.x */
/* based on */
/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"mview.h"
#include	<stdio.h>
#include	<stdlib.h>
#include	<iocslib.h>
#include	"view.h"
#include	"console.h"
#include	"func.h"
#include	"mail.h"
#include	"mime.h"
#include	"address.h"
#include	"sub.h"

#define		Print(msg)	StatusPut(msg)
#define		FOFF		1024

static int	top;
static T_BUFP	bp = {
	0, 0,
	DEFTAB, DEFTAB - 1, DEFCOL, 0
};

extern int	Formatstring(char *buf, MAILDATA*, int);
extern unsigned char	*MakeBuf(T_BUFP *bp, int size);

static int	getnext();
static void	viewredraw();
static void	putline(int, char*);
static int	KeyExec();
static int	ReadFile(T_BUFP*, char*);

static int	getnext()
{
	int	current = TargetNum;

	while (1) {
		if (++TargetNum >= MailNow)	TargetNum = 0;
		if (TargetNum == current)	return FALSE;
		if (!(Mail[TargetNum].fileflag & M_CHECK)) {
			return TRUE;
		}
	}
}

static void	viewredraw()
{
	int	rows = (top + PAGEROW <= bp.line)? PAGEROW:(bp.line - top);

	allput(0, rows, (char*)(*(bp.lp + top)));
	Formatstring(PrnTemp, Mail, TargetNum);
	TitlePut(PrnTemp);
	if (SendFlag) {
		ConsolePut("[q]I [w]VK[ [e]ҏW [c]Yt");
	} else {
		ConsolePut("[q]I [w]VK[ [f]ԐM[");
	}
}

static void	putline(int y, char *str)
{
	int	i;
	char	*p = str + 1, *w = PrnTemp;

	while (*p)	*w++ = *p++;
	i = w - PrnTemp;
	for (; i < DEFCOL; i++)	*w++ = ' ';
	*w = '\0';

	B_PUTMES(str[0], 0, y + 1, DEFCOL - 1, PrnTemp);
}

/* 샋[` */
static int	KeyExec(void)
{
	unsigned char	Key;

	viewredraw();

	while (1) {
		MKEY_WAIT();
		Key = MKEY_GET();

		switch (Key) {
		case KEYUP:
		case KEYP+KEYCTRL:
		case KEYE+KEYCTRL:
			if (top) {	/* uv */
				tscroll(1);
				putline(0, (char*)(*(bp.lp + (--top))));
			}
			break;

		case KEYDOWN:
		case KEYN+KEYCTRL:
		case KEYX+KEYCTRL:
			if (top + PAGEROW < bp.line) {	/* uv */
				/* XN[ */
				tscroll(0);
				putline(27, (char*)(*(bp.lp + (++top + 27))));
			}
			break;

		case KEYROLLDOWN:	/* uROLL DOWNv */
		case KEYZ+KEYCTRL:
		case KEYR+KEYCTRL:
		case KEYB:
		case KEYH+KEYCTRL:
			top -= PAGEROW - 1;	/* Py[Wړ */
			/* \[n[ƈv */
			if (top < 0)	top = 0;
			viewredraw();
			break;

		case KEYSPACE:
			if (top + PAGEROW >= bp.line) {
				if (getnext())	return TRUE;
				StatusPut("ǂ͂܂");
				break;
			}

		case KEYROLLUP:		/* uROLL UPv */
		case KEYV+KEYCTRL:
		case KEYC+KEYCTRL:
			top += PAGEROW - 1;	/* Py[Wړ */
			if (top + PAGEROW - 1 >= bp.line) {
				/* Eяo␳ */
				top = bp.line - PAGEROW;
				if (top < 0)	top = 0;
			}
			viewredraw();
			break;

		case KEYHOME:
		case KEYCM+KEYSHIFT:
		case KEYG:
			if (top) {
				top = 0;	/* 擪 */
				viewredraw();
			}
			break;

		case KEYHOME+KEYSHIFT:
		case KEYPR+KEYSHIFT:
		case KEYG+KEYSHIFT:
			if (top + PAGEROW < bp.line) {
				top = bp.line - PAGEROW;	/*  */
				if (top < 0)	top = 0;
				viewredraw();
			}
			break;

		case KEYW:		/* Vȃ[̍쐬 */
			WriteMail(NULL, NULL);
			break;

		case KEYF:
		case KEYR:		/* XԂ */
			ResMail();
			break;

		case KEYF+KEYSHIFT:	/* ] */
			WriteMail(&(Mail[TargetNum]), CDir);
			break;

		case KEYE:		/* ҏW */
			if (SendFlag == 2 && MailEdit())	return FALSE;
			break;

		case KEYX:		/* Yt@\ */
			if (SendFlag && !(Mail[TargetNum].fileflag & M_CHECK)) {
				if (MimeClip())	return FALSE;
			}
			break;

		case KEYX+KEYSHIFT:	/* Ytt@CWJ@\ */
			MimeExtract(&(Mail[TargetNum]), CDir);
			break;

		case KEYN:	/* ̋L */
			if (TargetNum < MailNow - 1) {
				++TargetNum;
				return TRUE;
			}
			StatusPut("Ō̃[ł");
			break;

		case KEYP:	/* ŐL */
			if (TargetNum) {
				--TargetNum;
				return TRUE;
			}
			StatusPut("ŏ̃[ł");
			break;

		case KEYA:	/* AhXo^ */
			AddressAdd(&(Mail[TargetNum]));
			break;

		case KEYC:	/* [ʖۑ */
			copymail(&(Mail[TargetNum]), CDir);
			break;

		case KEYR+KEYSHIFT:	/* [M */
			receive();
			break;

		case KEYESC:
		case KEYKK+KEYCTRL:
		case KEYQ:
		case KEYRETURN:
		case KEYM+KEYCTRL:
		case KEYLEFT:
		case KEYB+KEYCTRL:
		case KEYS+KEYCTRL:
		case KEYUNDO:
		case KEYU+KEYCTRL:
			return FALSE;
		}
	}
}

static int
ReadFile(bp, filename)
T_BUFP	*bp;
char	*filename;
{
	int	size;

	size = fsize(filename);
	if (size > 0) {
		struct _stdbuf	string;

		if (!(bp->lp= malloc(size + FOFF))) {
			Print("Can't alloc memory.");
			return	FALSE;
		}

		/* obt@ FILE \̂ɍv */
		string._ptr = string._base = (unsigned char*)bp->lp + FOFF;
		string._cnt = string._bufsiz = size;
		string._flag = _IOWRITE | _IOW | _IOBIN;
		string._file = -1;
		string._nback = 0;

		MakeViewFile(&string, NULL);
		size = string._bufsiz - string._cnt;
		if (!size) {
			free(bp->lp);
			return FALSE;
		}
		realloc(bp->lp, size + FOFF);
		if (!(bp->fbuf = malloc(size * 2))) {
			free(bp->lp);
			Print("Can't alloc memory.");
			return	FALSE;
		}
		size = MakeBuf(bp, size) - bp->fbuf;
		realloc(bp->fbuf, size);
		realloc(bp->lp, sizeof(char*) * bp->line);
		return	size;
	}
	Print("open error");
	return	FALSE;
}


int	viewopen(char *filename)
{
	int	ret;

	bp.fbuf = 0;
	bp.lp = 0;
	bp.line = 0;

	if (!ReadFile(&bp, filename))	return FALSE;

	top = 0;
	PutScreen = viewredraw;
	Print(filename);

	ret = KeyExec();

	Print(0);
	PutScreen = listredraw;

	if (bp.fbuf)	free(bp.fbuf);
	if (bp.lp)	free(bp.lp);

	return	ret;
}
